"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CodeMetadataCodec = void 0;
const codeMetadata_1 = require("../../core/codeMetadata");
const codeMetadata_2 = require("../typesystem/codeMetadata");
class CodeMetadataCodec {
    decodeNested(buffer) {
        const codeMetadata = codeMetadata_1.CodeMetadata.newFromBytes(buffer.slice(0, codeMetadata_1.CodeMetadataLength));
        return [new codeMetadata_2.CodeMetadataValue(codeMetadata), codeMetadata_1.CodeMetadataLength];
    }
    decodeTopLevel(buffer) {
        const codeMetadata = codeMetadata_1.CodeMetadata.newFromBytes(buffer);
        return new codeMetadata_2.CodeMetadataValue(codeMetadata);
    }
    encodeNested(codeMetadata) {
        return Buffer.from(codeMetadata.valueOf().toBytes());
    }
    encodeTopLevel(codeMetadata) {
        return Buffer.from(codeMetadata.valueOf().toBytes());
    }
}
exports.CodeMetadataCodec = CodeMetadataCodec;
//# sourceMappingURL=codemetadata.js.map