/// <reference types="node" />
import { List, Type } from "../typesystem";
import { BinaryCodec } from "./binary";
/**
 * Encodes and decodes "List" objects.
 */
export declare class ListBinaryCodec {
    private readonly binaryCodec;
    constructor(binaryCodec: BinaryCodec);
    decodeNested(buffer: Buffer, type: Type): [List, number];
    decodeTopLevel(buffer: Buffer, type: Type): List;
    encodeNested(list: List): Buffer;
    encodeTopLevel(list: List): Buffer;
}
