/// <reference types="node" />
import { OptionValue, Type } from "../typesystem";
import { BinaryCodec } from "./binary";
/**
 * Encodes and decodes "OptionValue" objects
 */
export declare class OptionValueBinaryCodec {
    private readonly binaryCodec;
    constructor(binaryCodec: BinaryCodec);
    decodeNested(buffer: Buffer, type: Type): [OptionValue, number];
    decodeTopLevel(buffer: Buffer, type: Type): OptionValue;
    encodeNested(optionValue: OptionValue): Buffer;
    encodeTopLevel(optionValue: OptionValue): Buffer;
}
