import { PrimitiveType, PrimitiveValue } from "./types";
export declare class BooleanType extends PrimitiveType {
    static ClassName: string;
    constructor();
    getClassName(): string;
}
/**
 * A boolean value fed to or fetched from a Smart Contract contract, as an immutable abstraction.
 */
export declare class BooleanValue extends PrimitiveValue {
    static ClassName: string;
    private readonly value;
    constructor(value: boolean);
    getClassName(): string;
    /**
     * Returns whether two objects have the same value.
     *
     * @param other another BooleanValue
     */
    equals(other: BooleanValue): boolean;
    isTrue(): boolean;
    isFalse(): boolean;
    valueOf(): boolean;
}
