/// <reference types="node" />
import { PrimitiveType, PrimitiveValue } from "./types";
export declare class BytesType extends PrimitiveType {
    static ClassName: string;
    constructor();
    getClassName(): string;
}
export declare class BytesValue extends PrimitiveValue {
    static ClassName: string;
    private readonly value;
    constructor(value: Buffer);
    getClassName(): string;
    /**
     * Creates a BytesValue from a utf-8 string.
     */
    static fromUTF8(value: string): BytesValue;
    /**
     * Creates a BytesValue from a hex-encoded string.
     */
    static fromHex(value: string): BytesValue;
    getLength(): number;
    /**
     * Returns whether two objects have the same value.
     */
    equals(other: BytesValue): boolean;
    valueOf(): Buffer;
    toString(): string;
}
