import BigNumber from "bignumber.js";
import { Type, TypedValue } from "./types";
export declare class ManagedDecimalSignedType extends Type {
    static ClassName: string;
    constructor(metadata: number | "usize");
    getClassName(): string;
    getMetadata(): number | "usize";
    isVariable(): boolean;
}
export declare class ManagedDecimalSignedValue extends TypedValue {
    static ClassName: string;
    private readonly value;
    private readonly scale;
    private readonly variable;
    constructor(value: BigNumber.Value, scale: number, isVariable?: boolean);
    getClassName(): string;
    getPrecision(): number;
    getScale(): number;
    /**
     * Returns whether two objects have the same value.
     */
    equals(other: ManagedDecimalSignedValue): boolean;
    valueOf(): BigNumber;
    toString(): string;
    isVariable(): boolean;
}
