import { CustomType, Type } from "./types";
export declare class TypeMapper {
    private readonly openTypesFactories;
    private readonly closedTypesMap;
    private readonly learnedTypesMap;
    constructor(learnedTypes?: CustomType[]);
    /**
     * Maps a "raw type" object to a "known (specific) type" object.
     * In the process, it also learns the new type.
     * Can only map types if their dependencies were previously learned (through mapping).
     */
    mapType(type: Type): Type;
    private mapTypeRecursively;
    private learnType;
    private mapStructType;
    private mapEnumType;
    private mapExplicitEnumType;
    private mappedFields;
    private mapGenericType;
}
