import { Address } from "./address";
export declare class SmartContractQuery {
    contract: Address;
    caller?: Address;
    value?: bigint;
    function: string;
    arguments?: Uint8Array[];
    constructor(options: {
        contract: Address;
        caller?: Address;
        value?: bigint;
        function: string;
        arguments?: Uint8Array[];
    });
}
export declare type SmartContractQueryInput = {
    contract: Address;
    caller?: Address;
    value?: bigint;
    function: string;
    arguments: any[];
};
export declare class SmartContractQueryResponse {
    function: string;
    returnCode: string;
    returnMessage: string;
    returnDataParts: Uint8Array[];
    constructor(obj: {
        function: string;
        returnCode: string;
        returnMessage: string;
        returnDataParts: Uint8Array[];
    });
    static fromHttpResponse(payload: any, functionName: string): SmartContractQueryResponse;
}
