import { Address } from "./address";
import { Transaction } from "./transaction";
interface Config {
    chainID: string;
    minGasLimit: bigint;
    gasLimitPerByte: bigint;
}
/**
 * @internal
 */
export declare class TransactionBuilder {
    private config;
    private sender;
    private receiver;
    private dataParts;
    private providedGasLimit;
    private addDataMovementGas;
    private amount?;
    constructor(options: {
        config: Config;
        sender: Address;
        receiver: Address;
        dataParts: string[];
        gasLimit: bigint;
        addDataMovementGas: boolean;
        amount?: bigint;
    });
    private computeGasLimit;
    private buildTransactionPayload;
    build(): Transaction;
}
export {};
