import { Address } from "../core/address";
import { ValidatorPublicKey } from "../wallet";
export declare type NewDelegationContractInput = {
    totalDelegationCap: bigint;
    serviceFee: bigint;
    amount: bigint;
};
export declare type AddNodesInput = ManageNodesInput & {
    signedMessages: Uint8Array[];
};
export declare type UnjailingNodesInput = ManageNodesInput & {
    amount: bigint;
};
export declare type ManageNodesInput = {
    delegationContract: Address;
    publicKeys: ValidatorPublicKey[];
};
export declare type ChangeServiceFee = {
    delegationContract: Address;
    serviceFee: bigint;
};
export declare type ModifyDelegationCapInput = {
    delegationContract: Address;
    delegationCap: bigint;
};
export declare type ManageDelegationContractInput = {
    delegationContract: Address;
};
export declare type DelegateActionsInput = {
    delegationContract: Address;
    amount: bigint;
};
export declare type SetContractMetadataInput = {
    delegationContract: Address;
    name: string;
    website: string;
    identifier: string;
};
