import { Address, Transaction, TransactionsFactoryConfig } from "../core";
import { ChangeConfigInput, ClearEndedProposalsInput, CloseProposalInput, NewProposalInput, VoteProposalInput } from "./resources";
export declare class GovernanceTransactionsFactory {
    private readonly config;
    private readonly argSerializer;
    private readonly governanceContract;
    constructor(options: {
        config: TransactionsFactoryConfig;
    });
    createTransactionForNewProposal(sender: Address, options: NewProposalInput): Transaction;
    createTransactionForVoting(sender: Address, options: VoteProposalInput): Transaction;
    createTransactionForClosingProposal(sender: Address, options: CloseProposalInput): Transaction;
    createTransactionForClearingEndedProposals(sender: Address, options: ClearEndedProposalsInput): Transaction;
    createTransactionForClaimingAccumulatedFees(sender: Address): Transaction;
    createTransactionForChangingConfig(sender: Address, options: ChangeConfigInput): Transaction;
}
