/**
 * An object holding network status configuration parameters.
 */
export declare class BlockOnNetwork {
    /**
     * The raw data return by provider.
     */
    raw: Record<string, any>;
    /**
     * The shard number.
     */
    shard: number;
    /**
     * The shard nonce.
     */
    nonce: bigint;
    /**
     * The block hash.
     */
    hash: string;
    /**
     * The block previous hash.
     */
    previousHash: string;
    /**
     * The block timestamp.
     */
    timestamp: number;
    /**
     * The block timestamp.
     */
    round: number;
    /**
     * The block timestamp.
     */
    epoch: number;
    /**
     * Constructs a configuration object from a HTTP response (as returned by the provider).
     */
    static fromHttpResponse(payload: any): BlockOnNetwork;
}
export declare class BlockCoordinates {
    nonce: bigint;
    hash: string;
    rootHash: string;
    constructor(init?: Partial<BlockCoordinates>);
    static fromHttpResponse(payload: any): BlockCoordinates;
}
