"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContractQueryRequest = void 0;
class ContractQueryRequest {
    constructor(query) {
        this.query = query;
    }
    toHttpRequest() {
        let request = {};
        let query = this.query;
        request.scAddress = query.contract.toBech32();
        request.caller = query.caller?.toBech32() ? query.caller.toBech32() : undefined;
        request.funcName = query.function;
        request.value = query.value ? query.value.toString() : undefined;
        request.args = query.arguments?.map((x) => Buffer.from(x).toString("hex"));
        return request;
    }
}
exports.ContractQueryRequest = ContractQueryRequest;
//# sourceMappingURL=contractQueryRequest.js.map