/**
 * An object holding network status configuration parameters.
 */
export declare class NetworkStatus {
    raw: Record<string, any>;
    /**
     * The block timestamp.
     */
    blockTimestamp: number;
    /**
     * The block nonce.
     */
    blockNonce: bigint;
    /**
     * The highest final nonce.
     */
    highestFinalNonce: bigint;
    /**
     * The current round.
     */
    currentRound: bigint;
    /**
     * The current epoch.
     */
    currentEpoch: number;
    constructor();
    /**
     * Constructs a configuration object from a HTTP response (as returned by the provider).
     */
    static fromHttpResponse(payload: any): NetworkStatus;
}
