/// <reference types="node" />
import BigNumber from "bignumber.js";
import { Address } from "../core/address";
export declare class DefinitionOfFungibleTokenOnNetwork {
    identifier: string;
    name: string;
    ticker: string;
    owner: Address;
    decimals: number;
    supply: BigNumber;
    isPaused: boolean;
    canUpgrade: boolean;
    canMint: boolean;
    canBurn: boolean;
    canChangeOwner: boolean;
    canPause: boolean;
    canFreeze: boolean;
    canWipe: boolean;
    canAddSpecialRoles: boolean;
    assets: Record<string, any>;
    static fromApiHttpResponse(payload: any): DefinitionOfFungibleTokenOnNetwork;
    /**
     * The implementation has been moved here from the following location:
     * https://github.com/multiversx/mx-sdk-js-core/blob/release/v9/src/token.ts
     */
    static fromResponseOfGetTokenProperties(identifier: string, data: Buffer[]): DefinitionOfFungibleTokenOnNetwork;
}
export declare class DefinitionOfTokenCollectionOnNetwork {
    collection: string;
    type: string;
    name: string;
    ticker: string;
    owner: Address;
    decimals: number;
    canPause: boolean;
    canFreeze: boolean;
    canWipe: boolean;
    canUpgrade: boolean;
    canChangeOwner: boolean;
    canAddSpecialRoles: boolean;
    canTransferNftCreateRole: boolean;
    canCreateMultiShard: boolean;
    static fromApiHttpResponse(payload: any): DefinitionOfTokenCollectionOnNetwork;
    /**
     * The implementation has been moved here from the following location:
     * https://github.com/multiversx/mx-sdk-js-core/blob/release/v9/src/token.ts
     */
    static fromResponseOfGetTokenProperties(collection: string, data: Buffer[]): DefinitionOfTokenCollectionOnNetwork;
}
