import { UserPublicKey, UserSecretKey } from "./userKeys";
export declare class KeyPair {
    readonly secretKey: UserSecretKey;
    readonly publicKey: UserPublicKey;
    constructor(secretKey: UserSecretKey);
    static generate(): KeyPair;
    static newFromBytes(data: Uint8Array): KeyPair;
    sign(data: Uint8Array): Promise<Uint8Array>;
    verify(data: Uint8Array, signature: Uint8Array): Promise<boolean>;
    getSecretKey(): UserSecretKey;
    getPublicKey(): UserPublicKey;
}
