import { UserSecretKey } from "./userKeys";
export declare class Mnemonic {
    private readonly text;
    private constructor();
    static generate(): Mnemonic;
    static fromString(text: string): Mnemonic;
    static fromEntropy(entropy: Uint8Array): Mnemonic;
    static assertTextIsValid(text: string): void;
    deriveKey(addressIndex?: number, password?: string): UserSecretKey;
    getWords(): string[];
    getEntropy(): Uint8Array;
    toString(): string;
}
