/// <reference types="node" />
import { Address } from "../core/address";
export declare const USER_SEED_LENGTH = 32;
export declare const USER_PUBKEY_LENGTH = 32;
export declare class UserSecretKey {
    private readonly buffer;
    constructor(buffer: Uint8Array);
    static fromString(value: string): UserSecretKey;
    static fromPem(text: string, index?: number): UserSecretKey;
    generatePublicKey(): UserPublicKey;
    static generate(): UserSecretKey;
    sign(message: Uint8Array): Uint8Array;
    hex(): string;
    valueOf(): Buffer;
}
export declare class UserPublicKey {
    private readonly buffer;
    constructor(buffer: Uint8Array);
    verify(data: Buffer | Uint8Array, signature: Buffer | Uint8Array): Promise<boolean>;
    hex(): string;
    toAddress(hrp?: string): Address;
    valueOf(): Buffer;
}
