import { Address } from "../core/address";
import { UserSecretKey } from "./userKeys";
/**
 * ed25519 signer
 */
export declare class UserSigner {
    readonly secretKey: UserSecretKey;
    constructor(secretKey: UserSecretKey);
    static fromWallet(keyFileObject: any, password: string, addressIndex?: number): UserSigner;
    static fromPem(text: string, index?: number): UserSigner;
    sign(data: Uint8Array): Promise<Uint8Array>;
    /**
     * Gets the address of the signer.
     */
    getAddress(hrp?: string): Address;
}
