/// <reference types="node" />
import { Address } from "../core/address";
import { UserPublicKey } from "./userKeys";
/**
 * ed25519 signature verification
 */
export declare class UserVerifier {
    publicKey: UserPublicKey;
    constructor(publicKey: UserPublicKey);
    static fromAddress(address: Address): UserVerifier;
    /**
     *
     * @param data the raw data to be verified (e.g. an already-serialized enveloped message)
     * @param signature the signature to be verified
     * @returns true if the signature is valid, false otherwise
     */
    verify(data: Buffer | Uint8Array, signature: Buffer | Uint8Array): Promise<boolean>;
}
